# DeepSparse
A deep and wide U-Net for generative denoising of sparse photon microscopy data

# Installation
```
git clone https://github.com/sheneman/sparse
cd sparse
python3 -m venv venv
source venv/bin/activate
pip install -U pip
pip install -r requirements.txt
```

# Training Models
```
python ./train.py <run_name> \
                  <output_dir_root (path string)> \
                  <train_root_path (path string)> \
                  <train_data_dir (path string)> \
                  <train_ground_truth_dir (path string)> \
                  <validation_root (path string)> \
                  <validation_data (path string)> \
                  <validation_ground_truth_dir (path string)> \
                  <image_size (integer)> \
                  <num_epochs (integer)> \
                  <batch_size (integer)> \
                  <kfold (0 | 1)> \
                  <max_unet_depth (integer)> \
                  <start_filter_num (integer>> \
                  <convolution_block_width (integer)> \
                  <optimizer (e.g. "adam")> \
                  <learning rate (float)> \
                  <loss_function (e.g. "binary_crossentropy">
```

Look at utils/train.slurm for examples of calling train.py under the SLURM HPC scheduler.

# Inference from Trained Models
```
python ./inference.py <path_to_source_sparse_images (path string)> \
                      <path_to_saved_model (path string)> \
                      <path_to_save_results (path string)>

```
Look at utils/inference.slurm for example of calling inference.py under the SLURM HPC scheduler.

# Contact

Contact Luke Sheneman (sheneman@uidaho.edu) with questions about code.
