##################################################################################
#
# 8bit.py
#
# Reads an image and converts to an (optionally normalized) 8bit image
#
##################################################################################
#
# Luke Sheneman, 2023
# sheneman@uidaho.edu
#
# Institute for Interdisciplinary Data Studies (IIDS)
# University of Idaho
#
##################################################################################
#
# MIT License
#
# Copyright (c) 2023 Luke Sheneman
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
################################################################################## 

import os, sys
import cv2

if(len(sys.argv)!=3):
	print("Usage:  python 8bit.py <input_file> <output_file>")
	exit()

INPUT_FILE = sys.argv[1]
OUTPUT_FILE = sys.argv[2]

image = cv2.imread(INPUT_FILE,flags=cv2.IMREAD_UNCHANGED)
#image = cv2.normalize(image,None,0,255,cv2.NORM_MINMAX,cv2.CV_8U)
img8 = (image/256).astype('uint8')
#img8 = image.astype('uint8')
cv2.imwrite(OUTPUT_FILE, img8)

print(OUTPUT_FILE)

